
package
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	
	public class Bullet extends Sprite
	{
		public var body: b2Body;
		
		public var dead: Boolean = false;
		
		public var bounces: int = 0;
		
		public function Bullet (world: b2World, p: b2Vec2, v: b2Vec2)
		{
			/*var image: Bitmap = new bulletSrc()
			
			image.x = -image.width / 2;
			image.y = -image.height / 2;
			
			addChild(image);*/
			
			graphics.beginFill(0xFFFFFF);
			graphics.drawCircle(0, 0, 3);
			graphics.endFill();
			
			x = p.x * 32;
			y = p.y * 32;
			
			// physics
			
			var bodyDef: b2BodyDef = new b2BodyDef();
			bodyDef.position = p.Copy();
			bodyDef.linearVelocity = v.Copy();
			bodyDef.userData = this;
			bodyDef.fixedRotation = true;
			bodyDef.isBullet = true;
			
			body = world.CreateBody(bodyDef);
			
			var circleDef: b2CircleDef = new b2CircleDef();
			circleDef.radius = 3.0 / 32.0;//image.width / 64.0;
			circleDef.density = 1.0;
			circleDef.friction = 0.0;
			circleDef.restitution = 1.0;
			circleDef.filter.groupIndex = -1;
			
			body.CreateShape(circleDef);
			
			body.SetMassFromShapes();
		}
		
	}

}


