
package
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	
	import Box2D.Dynamics.*;
	import Box2D.Dynamics.Contacts.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	
	public class MyContactListener extends b2ContactListener
	{
		public override function Add(point:b2ContactPoint) : void
		{
			var obj1 : * = point.shape1.GetBody().GetUserData();
			var obj2 : * = point.shape2.GetBody().GetUserData();
			
			var bullet: Bullet;
			var nonBullet: *;
			
			if (obj1 is Bullet)
			{
				bullet = obj1;
				nonBullet = obj2;
			}
			else if (obj2 is Bullet)
			{
				bullet = obj2;
				nonBullet = obj1;
			}
			
			if (bullet)
			{
				if (bullet.bounces == 0)
				{
					bullet.dead = true;
				}
				else
				{
					bullet.bounces -= 1;
				}
				
				if (nonBullet is Alien)
				{
					nonBullet.dead = true;
				}
				
				return;
			}
			
			var player: Player;
			var nonPlayer: *;
			
			if (obj1 is Player)
			{
				player = obj1;
				nonPlayer = obj2;
			}
			else if (obj2 is Player)
			{
				player = obj2;
				nonPlayer = obj1;
			}
			
			if (player)
			{
				if (nonPlayer is Alien)
				{
					if (! player.dying)
					{
						AudioControl.playPlayerDeathSound();
					}
					
					player.body.SetAngularDamping(0);
					
					player.dying = player.body.GetLocalPoint(point.position);
				}
				
				return;
			}
		}
	 
		public override function Persist(point:b2ContactPoint) : void
		{
			// handle persist point
		}
	 
		public override function Remove(point:b2ContactPoint) : void
		{
			// handle remove point
		}
	 
		public override function Result(point:b2ContactResult) : void
		{
			// handle results
		}
	}

}


